package sk.kasv;

import jakarta.persistence.*;

import java.util.ArrayList;
import java.util.List;


@Entity
@Table(name = "drivers-group")
public class Type {


  @Id
  @Column(name = "id")
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  private int id;

  @Column(name = "title")
  private String title;

  @ManyToOne(cascade = CascadeType.ALL,fetch = FetchType.LAZY)
  @JoinColumn(name = "educator_id")
  private educator educator;

  @OneToMany(fetch = FetchType.LAZY,cascade = CascadeType.ALL)
  @JoinColumn(name = "drivers-group_id")
  List<Rating> ratings=new ArrayList<>();


  @ManyToMany(fetch = FetchType.LAZY,
              cascade = {CascadeType.PERSIST,CascadeType.MERGE,CascadeType.DETACH, CascadeType.REFRESH})
  @JoinTable(name = "drivers-group_people",
             joinColumns = @JoinColumn(name = "drivers-group_id"),
             inverseJoinColumns = @JoinColumn(name = "people_id"))
  private List<People> people;

  public List<Rating> getRatings() {
    return ratings;
  }

  public void setRatings(List<Rating> ratings) {
    this.ratings = ratings;
  }

  public Type() {
  }

  public Type(String title) {
    this.title = title;
  }

  public int getId() {
    return id;
  }

  public void setId(int id) {
    this.id = id;
  }

  public String getTitle() {
    return title;
  }

  public void setTitle(String title) {
    this.title = title;
  }

  public educator getEducator() {
    return educator;
  }

  public void setEducator(educator educator) {
    this.educator = educator;
  }

  public void addRating(Rating rating) {
    if (rating == null) {
      ratings = new ArrayList<>();
    }
    ratings.add(rating);
  }

  public void addPeople(People peoples){
    if(peoples == null){
      people = new ArrayList<>();
    }

    people.add(peoples);
  }
}
